Unit ZNServerF;

Interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, Menus, ComCtrls, CheckLst,
  WinSock, WSocket, WSocketS, PosPanel;

Const
  WM_APPSTARTUP=WM_USER+1;

Type
  TInternerClient=Class(TWSocketClient)
                  Public
                    ConnectTime:TDateTime;
                    NeuesFormat:Boolean;
                    Paket:Array[0..65536] of Char; // Eins zuviel!
                    Anz,Ingnored:Integer;
                    TrennerMerker,LastTrenner:String;
                    KurzName,LangName:String;
                  End;

  TMainForm = class(TForm)
    ServerAlt: TWSocketServer;
    ServerNeu: TWSocketServer;
    UDP: TWSocket;
    ProtoBox: TListBox;
    UDPSuche: TWSocket;
    UDPSucheTimer: TTimer;
    PosPanel1: TPosPanel;
    ClientListe: TListBox;
    PosPanel2: TPosPanel;
    ServerPanel: TPosPanel;
    Label1: TLabel;
    Label2: TLabel;
    ServerListe2: TListBox;
    ServerListe1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure ServerAltBgException(Sender: TObject; E: Exception;
      var CanClose: Boolean);
    procedure ServerAltClientConnect(Sender: TObject; Client: TWSocketClient;
      Error: Word);
    procedure ServerAltClientDisconnect(Sender: TObject;
      Client: TWSocketClient; Error: Word);
    procedure FormShow(Sender: TObject);
    procedure ServerNeuBgException(Sender: TObject; E: Exception;
      var CanClose: Boolean);
    procedure ServerNeuClientConnect(Sender: TObject;
      Client: TWSocketClient; Error: Word);
    procedure ServerNeuClientDisconnect(Sender: TObject;
      Client: TWSocketClient; Error: Word);
    procedure UDPDataAvailable(Sender: TObject; Error: Word);
    procedure ClientListeDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ProtoBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure UDPSucheDataAvailable(Sender: TObject; Error: Word);
    procedure UDPSucheTimerTimer(Sender: TObject);
  private
    FInitialized:Boolean;
    ServerPortAlt:String;
    ServerPortNeu:String;

    Procedure WMAppStartup(var Msg: TMessage);Message WM_APPSTARTUP;
    Procedure IntClientDataAvailableAlt(Sender:TObject;Error:Word);
    Procedure IntClientDataAvailableNeu(Sender:TObject;Error:Word);
    Procedure ClientBgException(Sender:TObject;E:Exception;Var CanClose:Boolean);
    Function ClientIndex(s:String):Integer;
    Procedure AnAndereClientsWeiterleiten(Sender:TInternerClient;Neu:Boolean;Paket:String);
  public
    Function TrennerStr(ts:String):String;
    Function Norm(s:String;l:Integer):String;
    Function NormNum(s:String;l:Integer):String;
    Procedure Proto(s:String);
  end;

Var
  MainForm:TMainForm;

Implementation

{$R *.DFM}

Procedure TMainForm.FormCreate(Sender: TObject);
Begin
  Left:=0;
  Top:=0;
  FInitialized:=False;

  ServerPortAlt:='50099';
  ServerPortNeu:='50100';
End;

Procedure TMainForm.FormShow(Sender: TObject);
Begin
  If not FInitialized
  Then
  Begin
    FInitialized:=True;
    PostMessage(Handle,WM_APPSTARTUP,0,0); // Verzgerung bis Init-fertig!
  End;
End;

Function TMainForm.TrennerStr(ts:String):String;
Var
  i:Integer;
Begin
  If ts=''
  Then
    Result:=''
  Else
  Begin
    For i:=1 to Length(ts) do
    Begin
      Case ts[i] of
      #13:Result:=Result+'CR ';
      #10:Result:=Result+'LF ';
      End; // of Case
    End;
  End;
End;

Function TMainForm.Norm(s:String;l:Integer):String;
Begin
  Result:=Copy(s,1,l);
  If Length(Result)<l
  Then
    Result:=Result+StringOfChar(' ',l-Length(Result));
End;

Function TMainForm.NormNum(s:String;l:Integer):String;
Var
  i:Integer;
Begin
  Result:=Copy(s,1,l);
  If Length(Result)<l
  Then
    Result:=StringOfChar('0',l-Length(Result))+Result;
  For i:=1 to Length(Result) do
  Begin
    If not(Result[i] in ['0'..'9'])
    Then
      Result[i]:='0';
  End;
End;

Procedure TMainForm.Proto(s:String);
Begin
  ProtoBox.Items.Add(s);
  ProtoBox.ItemIndex:=ProtoBox.Items.Count-1;
End;

//******************************************************************************
//******************************************************************************
//******************************************************************************
// Vielen Dank an Franois PIETTE (8.12.1997 - V. 1.03)

Procedure TMainForm.WMAppStartup(Var Msg:TMessage);
Begin // Jetzt ist das Formular einsatzbereit!
  ServerAlt.Proto:='tcp';
  ServerAlt.Port:=ServerPortAlt;
  ServerAlt.Addr:='0.0.0.0';
  ServerAlt.Banner:='';
  ServerAlt.ClientClass:=TInternerClient;
  ServerAlt.Listen;

  ServerNeu.Proto:='tcp';
  ServerNeu.Port:=ServerPortNeu;
  ServerNeu.Addr:='0.0.0.0';
  ServerNeu.Banner:='';
  ServerNeu.ClientClass:=TInternerClient;
  ServerNeu.Listen;

  UDP.Addr:='0.0.0.0';
  UDP.Port:='57111';
  UDP.Proto:='udp';
  UDP.Listen;

  UDPSucheTimerTimer(Self);
End;

Procedure TMainForm.ServerAltBgException(Sender:TObject;E:Exception;Var CanClose:Boolean);
Begin // Sollte nie vorkommen...
  Proto('Server-Ausnahmefehler: '+E.ClassName+': '+E.Message);
  CanClose:=False; // Hoffentlich luft der Server weiter!
End;

Procedure TMainForm.ServerNeuBgException(Sender:TObject;E:Exception;Var CanClose:Boolean);
Begin // Sollte nie vorkommen...
  Proto('Server-Ausnahmefehler: '+E.ClassName+': '+E.Message);
  CanClose:=False; // Hoffentlich luft der Server weiter!
End;

Procedure TMainForm.ClientBgException(Sender:TObject;E:Exception;Var CanClose:Boolean);
Begin // Eventuell hat der Client sich beim Empfang beendet!
  Proto('Client-Ausnahmefehler: '+E.ClassName+': '+E.Message);
  CanClose:=True; // Client beenden!
End;

Function TMainForm.ClientIndex(s:String):Integer;
Var
  i:Integer;
Begin
  Result:=-1;
  For i:=0 to ClientListe.Items.Count-1 do
  Begin
    If Pos(s,ClientListe.Items[i])=1
    Then
      Result:=i;
  End;
End;

Procedure TMainForm.ServerAltClientConnect(Sender:TObject;Client:TWSocketClient;Error:Word);
Var
  IC:TInternerClient;
  s:String;
Begin
  IC:=(Client as TInternerClient);
  s:=IC.PeerAddr+':'+IC.PeerPort;
  If ClientIndex(s)<0
  Then
    ClientListe.Items.AddObject(s,IC);
  Proto('Verbinde mit Client '+IC.PeerAddr+':'+IC.PeerPort);
  IC.ConnectTime:=Now;
  IC.NeuesFormat:=False;
  IC.Anz:=0;
  IC.Ingnored:=0;
  IC.TrennerMerker:='';
  IC.LastTrenner:='';
  IC.KurzName:='';
  IC.LangName:='';

  IC.LineMode:=False;
  IC.LineEdit:=False;
  IC.OnDataAvailable:=IntClientDataAvailableAlt;
  IC.OnBgException:=ClientBgException;
End;

Procedure TMainForm.ServerNeuClientConnect(Sender:TObject;Client:TWSocketClient;Error:Word);
Var
  IC:TInternerClient;
  s:String;
Begin
  IC:=(Client as TInternerClient);
  s:=IC.PeerAddr+':'+IC.PeerPort;
  If ClientIndex(s)<0
  Then
    ClientListe.Items.AddObject(s,IC);
  Proto('Verbinde mit Client '+IC.PeerAddr+':'+IC.PeerPort);
  IC.ConnectTime:=Now;
  IC.NeuesFormat:=True;
  IC.Anz:=0;
  IC.Ingnored:=0;
  IC.TrennerMerker:='';
  IC.LastTrenner:='';
  IC.KurzName:='';
  IC.LangName:='';

  IC.LineMode:=False;
  IC.LineEdit:=False;
  IC.OnDataAvailable:=IntClientDataAvailableNeu;
  IC.OnBgException:=ClientBgException;
End;

Procedure TMainForm.ServerAltClientDisconnect(Sender:TObject;Client:TWSocketClient;Error:Word);
Var
  IC:TInternerClient;
  i:Integer;
  s:String;
Begin
  IC:=(Client as TInternerClient);
  s:=IC.PeerAddr+':'+IC.PeerPort;
  i:=ClientIndex(s);
  If i>=0
  Then
    ClientListe.Items.Delete(i);
  Proto('Trenne von Client '+IC.PeerAddr+':'+IC.PeerPort+', Dauer: '+FormatDateTime('hh:nn:ss',Now-IC.ConnectTime));
End;

Procedure TMainForm.ServerNeuClientDisconnect(Sender:TObject;Client:TWSocketClient;Error:Word);
Var
  IC:TInternerClient;
  i:Integer;
  s:String;
Begin
  IC:=(Client as TInternerClient);
  s:=IC.PeerAddr+':'+IC.PeerPort;
  i:=ClientIndex(s);
  If i>=0
  Then
    ClientListe.Items.Delete(i);
  Proto('Trenne von Client '+IC.PeerAddr+':'+IC.PeerPort+', Dauer: '+FormatDateTime('hh:nn:ss',Now-IC.ConnectTime));
End;

Procedure TMainForm.IntClientDataAvailableAlt(Sender:TObject;Error:Word);
Var
  IC:TInternerClient;
  i:Integer;
  z:String;

    Procedure DoIt(Trenner:String);
    Var
      i:Integer;
      s:String;
    Begin
      IC.TrennerMerker:=Trenner;
      s:='';
      For i:=0 to IC.Anz-1 do
        s:=s+IC.Paket[i];
      IC.Anz:=0;
      IC.Ingnored:=0;
      Proto(IC.PeerAddr+':'+IC.PeerPort+'|'+IC.LangName+'|'+IC.KurzName+'|'+s);
      AnAndereClientsWeiterleiten(IC,False,s);
    End;

Begin
  IC:=(Sender as TInternerClient);
  z:=IC.ReceiveStr;

  For i:=1 to Length(z) do
  Begin
    If z[i] in [#13,#10]
    Then
    Begin // Zeilentrenner:
      If IC.Anz=0
      Then // Trenner-Reste:
        IC.TrennerMerker:=IC.TrennerMerker+z[i] // Weitere!
      Else
        DoIt(z[i]);
    End
    Else If z[i]>=#32
    Then
    Begin // Inhalt...
      If IC.Anz=0
      Then
      Begin
        If IC.LastTrenner<>IC.TrennerMerker
        Then
        Begin
          IC.LastTrenner:=IC.TrennerMerker;
          ClientListe.Repaint;
        End;
      End;
      If IC.Anz<256
      Then
      Begin
        IC.Paket[IC.Anz]:=z[i];
        Inc(IC.Anz);
      End;
      If IC.Anz=20
      Then
        DoIt('');
    End
    Else
      Inc(IC.Ingnored);
  End;
End;

Procedure TMainForm.IntClientDataAvailableNeu(Sender:TObject;Error:Word);
Var
  IC:TInternerClient;
  i:Integer;
  z:String;

    Procedure DoIt(Trenner:String);
    Var
      i:Integer;
      s:String;
    Begin
      IC.TrennerMerker:=Trenner;
      s:='';
      For i:=0 to IC.Anz-1 do
        s:=s+IC.Paket[i];
      IC.Anz:=0;
      IC.Ingnored:=0;
      Proto(IC.PeerAddr+':'+IC.PeerPort+'|'+IC.LangName+'|'+IC.KurzName+'|'+s);
      AnAndereClientsWeiterleiten(IC,True,s);
    End;

Begin
  IC:=(Sender as TInternerClient);
  z:=IC.ReceiveStr;

  For i:=1 to Length(z) do
  Begin
    If z[i] in [#13,#10]
    Then
    Begin // Zeilentrenner:
      If IC.Anz=0
      Then // Trenner-Reste:
        IC.TrennerMerker:=IC.TrennerMerker+z[i] // Weitere!
      Else
        DoIt(z[i]);
    End
    Else If z[i]>=#32
    Then
    Begin // Inhalt...
      If IC.Anz=0
      Then
      Begin
        If IC.LastTrenner<>IC.TrennerMerker
        Then
        Begin
          IC.LastTrenner:=IC.TrennerMerker;
          ClientListe.Repaint;
        End;
      End;
      If IC.Anz<256
      Then
      Begin
        IC.Paket[IC.Anz]:=z[i];
        Inc(IC.Anz);
      End;
      //If IC.Anz=20
      //Then
      //  DoIt('');
    End
    Else
      Inc(IC.Ingnored);
  End;
End;

Procedure TMainForm.AnAndereClientsWeiterleiten(Sender:TInternerClient;Neu:Boolean;Paket:String);
Var
  i,j,p,BefehlAlt,dp:Integer;
  hh,mm,ss:String;
  PaketAlt,PaketNeu,Typ:String;
  Weiterleiten:Boolean;

    Procedure DoID(k,l:String);
    Begin
      Sender.KurzName:=Trim(Norm(k,5));
      Sender.LangName:=Trim(l);
      ClientListe.Repaint;
    End;

Begin
  If Neu
  Then
  Begin
    dp:=Pos(':',Paket);
    Weiterleiten:=(dp>0);
    If Weiterleiten
    Then
    Begin
      Typ:=Copy(Paket,1,dp-1);
      Paket:=Copy(Paket,dp+1,Length(Paket)-dp);
      If Typ='ID'
      Then
      Begin
        Weiterleiten:=False;
        p:=Pos(',',Paket);
        If p<1
        Then
          DoID(Paket,Paket)
        Else
          DoID(Copy(Paket,1,p-1),Copy(Paket,p+1,Length(Paket)-p));
      End
      Else If Typ='ZLV'
      Then
      Begin
        PaketNeu:='ZLV:'+Paket;
        If Length(Paket)<20
        Then
          PaketAlt:=Paket+StringOfChar(' ',20-Length(Paket))
        Else
          PaketAlt:=Copy(Paket,1,20);
      End
      Else If Typ='UHR'
      Then
      Begin
        hh:=NormNum(Copy(Paket,1,2),2);
        mm:=NormNum(Copy(Paket,4,2),2);
        ss:=NormNum(Copy(Paket,7,2),2);
        PaketNeu:='UHR:'+hh+':'+mm+':'+ss;
        PaketAlt:='9991'+hh+':'+mm+':'+ss+'        ';
      End
      Else If Typ='PING'
      Then
      Begin
        Weiterleiten:=False;
        Sender.SendStr('PONG:'+#13#10);
      End;
    End;
  End
  Else
  Begin // Alt:
    Weiterleiten:=True;
    If Length(Paket)<20
    Then
      PaketAlt:=Paket+StringOfChar(' ',20-Length(Paket))
    Else
      PaketAlt:=Copy(Paket,1,20);
    Val(Copy(Paket,3,2),BefehlAlt,j);
    Case BefehlAlt of
    91:Begin // Uhrzeit
         hh:=NormNum(Copy(PaketAlt,5,2),2);
         mm:=NormNum(Copy(PaketAlt,8,2),2);
         ss:=NormNum(Copy(PaketAlt,11,2),2);
         PaketNeu:='UHR:'+hh+':'+mm+':'+ss;
       End;
    92:Begin // ID
         Weiterleiten:=False;
         DoID(Copy(PaketAlt,7,Length(PaketAlt)-6),Copy(PaketAlt,7,Length(PaketAlt)-6));
       End;
    Else
      PaketNeu:='ZLV:'+PaketAlt;
    End; // of Case
  End;

  If Weiterleiten
  Then
  Begin
    For i:=0 to ServerNeu.ClientCount-1 do
    Begin
      If (not Neu) or (Sender<>ServerNeu.Client[i])
      Then
        ServerNeu.Client[i].SendStr(PaketNeu+#13#10);
    End;

    For i:=0 to ServerAlt.ClientCount-1 do
    Begin
      If Neu or (Sender<>ServerAlt.Client[i])
      Then
        ServerAlt.Client[i].SendStr(PaketAlt+#13#10);
    End;
  End;
End;

Procedure TMainForm.UDPDataAvailable(Sender: TObject; Error: Word);
Var
  Buffer:Array[0..2047] of Char;
  Len:Integer;
  Src:TSockAddrIn;
  SrcLen:Integer;
  a:String[80];
  s:String;
Begin
  SrcLen:=SizeOf(Src);
  Try // UDP=(Sender as TWSocket)!!!
    Len:=UDP.ReceiveFrom(@Buffer,SizeOf(Buffer)-1,Src,SrcLen);
    If Len>=0
    Then
    Begin
      Buffer[Len]:=#0;
      s:=StrPas(Buffer);
      If s='ZNSERVER?'
      Then
      Begin
        //Proto('UDP-Serversuche von '+StrPas(inet_ntoa(Src.sin_addr))+':'+IntToStr(ntohs(Src.sin_port)));
        a:='ZNSERVERPORT:'+ServerPortNeu;
        UDP.SendTo(Src,SrcLen,@a[1],Length(a));
      End
      Else
        Proto('UDP: '+StrPas(inet_ntoa(Src.sin_addr))+':'+IntToStr(ntohs(Src.sin_port))+': '+s);
    End;
  Except
    On E:Exception do Proto('UDP-Fehler: '+E.Message);
  End;
End;

Procedure TMainForm.ClientListeDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
Var
  can:TCanvas;
  s,h:String;
  IC:TInternerClient;
Begin
  can:=ClientListe.Canvas;
  s:=ClientListe.Items[Index];
  IC:=(ClientListe.Items.Objects[Index] as TInternerClient);

  can.Brush.Style:=bsSolid;
  If IC.NeuesFormat
  Then
    can.Brush.Color:=clWhite
  Else
    can.Brush.Color:=clSilver;
  can.FillRect(Rect);
  can.Pen.Mode:=pmCopy;
  can.Pen.Style:=psSolid;
  can.Pen.Color:=clBlack;
  can.Pen.Width:=1;
  can.Rectangle(Rect);

  can.Brush.Style:=bsClear;
  can.Font.Color:=clBlack;
  can.TextOut(Rect.Left+2,Rect.Top,s);
  can.TextOut(Rect.Left+2,Rect.Top+16,'Verbunden '+TimeToStr(IC.ConnectTime));
  h:=TrennerStr(IC.LastTrenner);
  can.TextOut(Rect.Right-2-can.TextWidth(h),Rect.Top+16,h);
  If IC.KurzName=IC.LangName
  Then
    can.TextOut(Rect.Left+2,Rect.Top+32,IC.LangName)
  Else
    can.TextOut(Rect.Left+2,Rect.Top+32,IC.KurzName+' / '+IC.LangName);
End;

Procedure TMainForm.ProtoBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
Var
  can:TCanvas;
  s,ip,adr,ln,kn,ls:String;
  p:Integer;

    Function Next:String;
    Var
      p:Integer;
    Begin
      p:=Pos('|',s);
      If p>=1
      Then
      Begin
        Result:=Copy(s,1,p-1);
        s:=Copy(s,p+1,Length(s)-p);
      End
      Else
      Begin
        Result:=s;
        s:='';
      End;
    End;

Begin
  can:=ProtoBox.Canvas;
  s:=ProtoBox.Items[Index];
  can.FillRect(Rect);
  p:=Pos('|',s);
  If p>=1
  Then
  Begin
    ip:=Next;
    ln:=Next;
    kn:=Next;
    ls:=IntToStr(Length(s))+' Byte';

    can.Font.Name:='Arial';
    can.Font.Height:=16;
    can.Font.Style:=[];
    If ln<>''
    Then
    Begin
      adr:=ln;
      If kn<>''
      Then
        adr:=adr+' ('+kn+')';
      can.Font.Style:=[fsBold];
      can.TextOut(Rect.Left+2,Rect.Top,adr);
      can.Font.Style:=[];
      can.Font.Height:=12;
      can.TextOut(Rect.Left+240-can.TextWidth('('+ip+')'),Rect.Top+2,'('+ip+')');
    End
    Else
    Begin
      can.Font.Style:=[fsBold];
      can.TextOut(Rect.Left+2,Rect.Top,ip);
    End;
    can.Font.Height:=12;
    can.Font.Style:=[];
    can.TextOut(Rect.Left+290-can.TextWidth(ls),Rect.Top+2,ls);
    can.Font.Height:=16;
    can.Font.Name:='Courier New';
    can.Font.Style:=[fsBold];
    can.TextOut(Rect.Left+300,Rect.Top,s);
    can.Font.Style:=[];
  End
  Else
  Begin
    can.Font.Name:='Arial';
    can.Font.Height:=16;
    can.Font.Style:=[];
    can.TextOut(Rect.Left+2,Rect.Top,s);
  End;
End;



Procedure TMainForm.UDPSucheDataAvailable(Sender: TObject; Error: Word);
Var
  Buffer:Array[0..2047] of Char;
  Len,p:Integer;
  Src:TSockAddrIn;
  SrcLen:Integer;
  s:String;
Begin
  SrcLen:=SizeOf(Src);
  Try // UDPSuche=(Sender as TWSocket)!!!
    Len:=UDPSuche.ReceiveFrom(@Buffer,SizeOf(Buffer)-1,Src,SrcLen);
    If Len>=0
    Then
    Begin
      Buffer[Len]:=#0;
      s:=StrPas(Buffer);

      p:=Pos('ZNSERVERPORT:',s);
      If p=1
      Then
        ServerListe1.Items.Add(StrPas(inet_ntoa(Src.sin_addr)));
    End;
  Except
  End;
End;

Procedure TMainForm.UDPSucheTimerTimer(Sender: TObject);
Var
  i:Integer;
Begin
  ServerListe2.Clear;
  For i:=0 to ServerListe1.Items.Count-1 do
    ServerListe2.Items.Add(ServerListe1.Items[i]);
  If (ServerListe2.Items.Count>1)
  Then
    ServerPanel.Color:=clRed
  Else
    ServerPanel.Color:=clLime;

  ServerListe1.Clear;
  Try
    UDPSuche.Addr:='255.255.255.255';
    UDPSuche.Port:='57111';
    UDPSuche.Proto:='udp';
    If UDPSuche.State=wsClosed
    Then
      UDPSuche.Connect;
    UDPSuche.SendStr('ZNSERVER?');
  Except
  End;
End;

End.

